unit MontanaU;

{ Montana is een kaartspel met 104 kaarten die allen open worden gelegd in
  8 rijen van 13 kaarten. Alle azen worden verwijderd en vooraan neergelegd.
  De opdracht is om telkens een kaart te verplaatsen naar een lege plek.

  Ingredienten:

  InitArray[0..103] of integer := bevat alle kaarten op volgorde,
                                  wordt gebruikt bij het initialiseren.
  CardColor[0..12,0..7] of integer := daadwerkelijke data per kaart.
    0 : geen kaart
    1 : ruiten
    2 : harten
    3 : klaveren
    4 : schoppen
  CardNumber[0..12,0..7] of integer := daadwerkelijke data per kaart.
  CardFase[0..12,0..7] of integer := de fase waarin de kaart zich bevindt.

  IniFile : Montana.ini:
  [Names]
  Num=2
  Name1=Matthijs
  Name2=Govert
  Last=Matthijs
  [Options]
  Afmeting = 0/1
  Kleur = 0/1
  Snelheid = 0/1
  [1]...[100]
  max=100
  auteur=Matthijs
  min=236
  [Last]
  Matthijs=1
  Govert=3
  [Matthijs1]
  max=100
  min=236
  [Govert1]
  max=100
  min=247

  Nieuwe ideeen:
  toevoegen van klok
  naam
  spel
  verplaatsen van knoppen
  aftellen indien gewenst
  na aftelling geen undu of restart meer
  tijdsduur uitdrukken in minuten

  Fouten
  Snel annuleren bij kleine afmeting
  undu bij traag annuleren
  forward
  kleuren niet geheel correct
  ingedrukt zichtbaar niet geheel correct
}

interface

uses
  WinTypes, WinProcs, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls, Buttons, Menus, IniFiles;

const BasicCardNumberStrings : Array[1..13] of string[4] =
      ('   A', '   2', '   3', '   4', '   5', '   6', '   7', '   8', '   9',
       '  1O', '   B', '   V', '   H');
      DutchStrings : Array[11..13] of string[4] = ('   B', '   V', '   H');
      EnglishStrings : Array[11..13] of string[4] = ('   J', '   Q', '   K');
      CardColorChars : Array[1..4] of string[4] =
      ('  '#168, '  '#169, '  '#167, '  '#170); {R, H, K, S}
      clDefault = clWhite;
      clReady = clSilver;
      clSelected = clAqua;
      clMarkSelected = clTeal;
      clAse = clYellow;
      clMarkNormal = clLime;
      clMarkWarning = clFuchsia;
      clShow = clWhite;
      clDead = clRed;
      clEmpty = clYellow;
      clNull = clBlack;
      mod1 = 104;
      mod2 = 10816;
      montanainifilename = 'Montana.ini';
      Strings : Array[1..4] of String =
                ('Kies een Aas', 'Kan deze kaart niet verplaatsen', 'Error',
                 'Het spel is ten einde'#13'U kunt geen kaart meer verplaatsen'#13'U heeft ');

type
  TCardPanels = Array[0..12,0..7] of TPanel;
  TCardLabels = Array[0..12,0..7] of TLabel;
  TAPanels = Array[0..7] of TPanel;
  TALabels = Array[0..7] of TLabel;
  TMontanaForm = class(TForm)
    CardPanel: TPanel;
    HelpPanel: TPanel;
    MemoNl: TMemo;
    ActionPanel: TPanel;
    Label1: TLabel;
    PuntenLabel: TLabel;
    Bevel1: TBevel;
    CountLabel: TLabel;
    Label2: TLabel;
    NormalPanel: TPanel;
    WarningPanel: TPanel;
    ToPanel: TPanel;
    FromPanel: TPanel;
    Timer1: TTimer;
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    New1: TMenuItem;
    Open1: TMenuItem;
    Save1: TMenuItem;
    Exit1: TMenuItem;
    Settings1: TMenuItem;
    MarkOK1: TMenuItem;
    MarkWarning1: TMenuItem;
    ShowTo1: TMenuItem;
    ShowFrom1: TMenuItem;
    ThisGame1: TMenuItem;
    Restart1: TMenuItem;
    Back1: TMenuItem;
    Next1: TMenuItem;
    Help1: TMenuItem;
    Help2: TMenuItem;
    About1: TMenuItem;
    PanelHelp: TPanel;
    ButtonCloseHelp: TButton;
    Score1: TMenuItem;
    Markering1: TMenuItem;
    OptionPanel: TPanel;
    SpeedButtonAnderSpel: TSpeedButton;
    SpeedButtonExit: TSpeedButton;
    SpeedButtonSave: TSpeedButton;
    SpeedButtonScore: TSpeedButton;
    SpeedButtonRestart: TSpeedButton;
    SpeedButtonPrevious: TSpeedButton;
    SpeedButtonNext: TSpeedButton;
    MemoEng: TMemo;
    SpeedButtonSettings: TSpeedButton;
    Label3: TLabel;
    NrLabel: TLabel;
    Label4: TLabel;
    NameLabel: TLabel;
    SpeedButtonHelp: TSpeedButton;
    procedure FormCreate(Sender: TObject);
    procedure ResetButtonClick(Sender: TObject);
    procedure MarkPanelClick(Sender: TObject);
    procedure RestartButtonClick(Sender: TObject);
    procedure CardClick(Sender: TObject);
    procedure UndoButtonClick(Sender: TObject);
    procedure CardMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Timer1Timer(Sender: TObject);
    procedure NextButtonClick(Sender: TObject);
    procedure Help2Click(Sender: TObject);
    procedure ButtonCloseHelpClick(Sender: TObject);
    procedure Exit1Click(Sender: TObject);
    procedure MarkOK1Click(Sender: TObject);
    procedure MarkWarning1Click(Sender: TObject);
    procedure ShowTo1Click(Sender: TObject);
    procedure ShowFrom1Click(Sender: TObject);
    procedure About1Click(Sender: TObject);
    procedure Settings1Click(Sender: TObject);
    procedure SpeedButtonSaveClick(Sender: TObject);
    procedure SpeedButtonScoreClick(Sender: TObject);
    procedure Score1Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    { Private declarations }
    CardPanels : TCardPanels;
    CardColorLabels : TCardLabels;
    CardNumberLabels : TCardLabels;
    APanels : TAPanels;
    AColorLabels : TALabels;
    ANumberLabels : TALabels;
    Function CheckCard(b1, h1, b2, h2 : Integer) : Boolean;
    procedure InitializeGame(n : integer);
    procedure DutchGame;
    procedure EnglishGame;
    procedure SetColors;
    procedure PlaceForm;
    procedure PlaceCards;
    procedure SetCards;
    procedure Select(no : integer);
    procedure Unselect(no : integer);
    function  MoveCard(P1, P2 : Integer) : Boolean;
    function  PlaceCard(b, h : Integer) : Integer;
    function  RemoveCard(b, h : Integer) : Integer;
    procedure PlaceAse(h, ColorNo : Integer);
    procedure ShowTo(b, h : Integer);
    procedure ShowFrom(b, h : Integer);
    procedure UndoLastAction;
  public
    { Public declarations }
  end;

var
  MontanaForm: TMontanaForm;
  Cards : Array[0..103] of integer;
  CardColor : Array[0..12,0..7] of integer;
  CardNumber : Array[0..12,0..7] of integer;
  CardFase : Array[0..12,0..7] of integer;
  CardPosition : Array[1..13,1..4,1..2] of integer;
  CardEmpty : Array[0..7] of integer;
  CardEmptyState : Array[0..7] of integer;
  FinalCardColor : Array[0..7] of integer;
  Moves : Array[-2..1000] of integer;
  Phase, M_b1, M_b2, M_h1, M_h2, MoveCount, MaxCount,
  NewB, NewH, ShowB, ShowH: Integer;
  SelectedB, SelectedH : Array[0..2] of integer;
  OldColor : Array[0..2] of TColor;
  SelectFlag : Array[0..2] of Boolean;
  C_1, C_2, clMark : TColor;
  LargeFlag, FastFlag, ColorFlag, DutchFlag : Boolean;
  Player : String;
  CardNumberStrings : Array[1..13] of string[4];

implementation

uses ChoiceU, OptionsU, NameU, ScoreU;

{$R *.DFM}

procedure TMontanaForm.PlaceForm;
begin
  if LargeFlag then {GROOT}
  begin
    with MontanaForm do
    begin
      Width := 721;
      Height := 551;
    end;
    with HelpPanel do
    begin
      Width := 649;
      Height := 465;
      Top := 2;
      Left := 1;
    end;
    with PuntenLabel do
    begin
      Width := 26;
      Height := 13;
      Top := 13;
      Left := 8;
      Font.Style := [fsBold];
      Font.Size := 10;
    end;
    with Label1 do
    begin
      Width := 48;
      Height := 13;
      Top := 13;
      Left := 40;
      Font.Style := [fsBold];
      Font.Size := 10;
    end;
    with Label2 do
    begin
      Width := 51;
      Height := 13;
      Top := 13;
      Left := 94;
      Font.Style := [fsBold];
      Font.Size := 10;
    end;
    with CountLabel do
    begin
      Width := 33;
      Height := 13;
      Top := 13;
      Left := 144;
      Font.Style := [fsBold];
      Font.Size := 10;
    end;
    with Bevel1 do
    begin
      Width := 263;
      Height := 27;
      Top := 6;
      Left := 191;
    end;
    with NormalPanel do
    begin
      Width := 65;
      Height := 25;
      Top := 7;
      Left := 192;
      Font.Style := [fsBold];
      Font.Size := 10;
    end;
    with WarningPanel do
    begin
      Width := 65;
      Height := 25;
      Top := 7;
      Left := 257;
      Font.Style := [fsBold];
      Font.Size := 10;
    end;
    with ToPanel do
    begin
      Width := 65;
      Height := 25;
      Top := 7;
      Left := 322;
      Font.Style := [fsBold];
      Font.Size := 10;
    end;
    with FromPanel do
    begin
      Width := 65;
      Height := 25;
      Top := 7;
      Left := 387;
      Font.Style := [fsBold];
      Font.Size := 10;
    end;
    SpeedButtonRestart.Top :=5;
    SpeedButtonPrevious.Top := 5;
    SpeedButtonNext.Top := 5;
    SpeedButtonRestart.Left :=500;
    SpeedButtonPrevious.Left := 527;
    SpeedButtonNext.Left := 554;
    SpeedButtonSave.Top := 286;
    SpeedButtonAnderSpel.Top := 316;
    SpeedButtonScore.Top :=346;
    SpeedButtonSettings.Top := 376;
    SpeedButtonHelp.Top := 406;
    SpeedButtonExit.Top := 436;
  end
  else {klein}
  begin
    with MontanaForm do
    begin
      Width := 558;
      Height := 472;
    end;
    with HelpPanel do
    begin
      Width := 480;
      Height := 388;
      Top := 2;
      Left := 1;
    end;
    with PuntenLabel do
    begin
      Width := 22;
      Height := 13;
      Top := 6;
      Left := 5;
      Font.Style := [];
      Font.Size := 8;
    end;
    with Label1 do
    begin
      Width := 40;
      Height := 13;
      Top := 6;
      Left := 29;
      Font.Style := [];
      Font.Size := 8;
    end;
    with Label2 do
    begin
      Width := 24;
      Height := 13;
      Top := 6;
      Left := 74;
      Font.Style := [];
      Font.Size := 8;
    end;
    with CountLabel do
    begin
      Width := 27;
      Height := 13;
      Top := 6;
      Left := 98;
      Font.Style := [];
      Font.Size := 8;
    end;
    with Bevel1 do
    begin
      Width := 222;
      Height := 23;
      Top := 5;
      Left := 131;
    end;
    with NormalPanel do
    begin
      Width := 56;
      Height := 21;
      Top := 6;
      Left := 132;
      Font.Style := [];
      Font.Size := 8;
    end;
    with WarningPanel do
    begin
      Width := 56;
      Height := 21;
      Top := 6;
      Left := 186;
      Font.Style := [];
      Font.Size := 8;
    end;
    with ToPanel do
    begin
      Width := 56;
      Height := 21;
      Top := 6;
      Left := 241;
      Font.Style := [];
      Font.Size := 8;
    end;
    with FromPanel do
    begin
      Width := 56;
      Height := 21;
      Top := 6;
      Left := 296;
      Font.Style := [];
      Font.Size := 8;
    end;
    SpeedButtonRestart.Top :=5;
    SpeedButtonPrevious.Top := 5;
    SpeedButtonNext.Top := 5;
    SpeedButtonRestart.Left :=400;
    SpeedButtonPrevious.Left := 427;
    SpeedButtonNext.Left := 454;
    SpeedButtonSave.Top := 198;
    SpeedButtonAnderSpel.Top := 228;
    SpeedButtonScore.Top :=258;
    SpeedButtonSettings.Top := 288;
    SpeedButtonHelp.Top := 318;
    SpeedButtonExit.Top := 348;
  end;
end;

procedure TMontanaForm.DutchGame;
var t : integer;
begin
  Back1.Caption := '&Terug';
  ButtonCloseHelp.Caption := 'Terug';
  ButtonCloseHelp.Hint := 'Afsluiten van Help-tekst';
  Exit1.Caption := '&Einde';
  File1.Caption := '&Bestand';
  FromPanel.Caption := 'Van';
  FromPanel.Hint := 'Selecteer met de rechter muistoets'#13 +
                    'een kaart en welke kaarten hier'#13'Kunnen worden gelegd.';
  Help1.Caption := '&Help';
  Help2.Caption := '&Hoe te spelen?';
  Label1.Caption := 'Punten';
  Label2.Caption := 'Zet:';
  Markering1.Caption := '&Markering';
  MarkOK1.Caption := 'Kies &OK';
  MarkWarning1.Caption := 'Kies &Gevaar';
  MemoNl.Visible := True;
  MemoEng.Visible := False;
  Next1.Caption := 'Zet &Vooruit';
  NormalPanel.Hint := 'Markeer kaarten met de rechter'#13'muistoets die voordelig liggen';
  Open1.Caption := '&Open spel';
  Restart1.Caption := '&Opnieuw spelen';
  Save1.Caption := '&Bewaren';
  Settings1.Caption := 'Instellingen';
  ShowFrom1.Caption := 'Keuze &Van';
  ShowTo1.Caption := 'Keuze &Naar';
  SpeedButtonAnderSpel.Hint := 'Start een ander spel';
  SpeedButtonExit.Hint := 'Verlaat Montana';
  SpeedButtonNext.Hint := 'Een zet vooruit';
  SpeedButtonPrevious.Hint := 'Een zet terug';
  SpeedButtonRestart.Hint := 'Spel opnieuw starten';
  Speedbuttonsave.Hint := 'Bewaar spel';
  ThisGame1.Caption := '&Dit spel';
  ToPanel.Caption := 'Naar';
  ToPanel.Hint := 'Click een kaart met de rechter muis-'#13'toets. Plaatsen waar de kaart heen kan'#13'worden geselecteerd';
  WarningPanel.Hint := 'Markeer kaarten met de rechter'#13'muistoets als gevaarlijk';
  WarningPanel.Caption := 'Gevaar';
  Label3.Caption := 'Spel';
  Label4.Caption := 'Naam';
  for t := 11 to 13 do
    CardNumberStrings[t] := DutchStrings[t];
end;

procedure TMontanaForm.EnglishGame;
var t : integer;
begin
  Back1.Caption := '&Back';
  ButtonCloseHelp.Caption := 'Back';
  ButtonCloseHelp.Hint := 'Close Help-text';
  Exit1.Caption := '&Exit';
  File1.Caption := '&File';
  FromPanel.Caption := 'From';
  FromPanel.Hint := 'Select with the right mousebutton'#13 +
                    'a location. Cards are selected which can be laid here.';
  Help1.Caption := '&Help';
  Help2.Caption := '&How to play?';
  Label1.Caption := 'Points';
  Label2.Caption := 'Move:';
  Markering1.Caption := '&Marks';
  MarkOK1.Caption := 'Mark &OK';
  MarkWarning1.Caption := 'Mark &Warning';
  MemoNl.Visible := False;
  MemoEng.Visible := True;
  Next1.Caption := 'Move &Forward';
  NormalPanel.Hint := 'Mark cards with the right mousebutton'#13'which lay good';
  Open1.Caption := '&Open';
  Restart1.Caption := '&Restart';
  Save1.Caption := '&Save';
  Settings1.Caption := '&Settings';
  ShowFrom1.Caption := 'Setting &From';
  ShowTo1.Caption := 'Setting &To';
  SpeedButtonAnderSpel.Hint := 'Start another game';
  SpeedButtonExit.Hint := 'Exit Montana';
  SpeedButtonNext.Hint := 'A move forward';
  SpeedButtonPrevious.Hint := 'A move back';
  SpeedButtonRestart.Hint := 'Game restart';
  Speedbuttonsave.Hint := 'Save game';
  ThisGame1.Caption := '&This Game';
  ToPanel.Caption := 'To';
  ToPanel.Hint := 'Click a card with the right mousebutton.'#13'The locations where the card can go to will'#13'be marked';
  WarningPanel.Hint := 'Markeer kaarten met de rechter'#13'muistoets als gevaarlijk';
  WarningPanel.Caption := 'Warning';
  Label3.Caption := 'Game';
  Label4.Caption := 'Name';
  for t := 11 to 13 do
    CardNumberStrings[t] := EnglishStrings[t];
end;

procedure TMontanaForm.InitializeGame(n : integer);
var
  h, b, t, r, i : integer;
  InitArray : Array[0..103] of integer;
begin
  for b := 1 to 13 do
  for h := 1 to 4 do
  for i := 1 to 2 do
    CardPosition[b,h,i] := -1;
  for h := 0 to 7 do FinalCardColor[h] := -1;
  Phase := 0;
  MoveCount := 0;
  CountLabel.Caption := '0';
  M_b1 := -1;
  M_b2 := -1;
  M_h1 := -1;
  M_h2 := -1;
  if n >= 0 then
  begin
    NrLabel.Caption := IntToStr(n);
    for i := 0 to 103 do InitArray[i] := i;
    for t := 0 to 103 do
    begin
      if n = 0 then r := Random(104 - t)
               else r := (n + 14456793) mod (104 - t);
      Cards[t] := InitArray[r];
      for i := r to 102 - t do InitArray[i] := InitArray[i + 1];
    end;
  end;
  for h := 0 to 7 do
  for b := 0 to 12 do
  begin
    t := 13 * h + b;
    CardPanels[b,h].Color := clDefault;
    CardPanels[b,h].Font.Color := clDefault;
    CardNumber[b,h] := 1 + Cards[t] mod 13;
    CardColor[b,h] := 1 + Cards[t] div 26;
    if CardPosition[CardNumber[b,h],CardColor[b,h],1] = -1
      then CardPosition[CardNumber[b,h],CardColor[b,h],1] := t
      else CardPosition[CardNumber[b,h],CardColor[b,h],2] := t;
    PlaceCard(b, h);
  end;
  for h := 0 to 7 do
  begin
    APanels[h].Color := clReady;
    AColorLabels[h].Caption := '';
    ANumberLabels[h].Caption := '';
    //OldColor := clNull;
  end;
  {SetColors;}
end;

procedure TMontanaForm.PlaceCards;
var
  h, b, t : integer;
begin
  for t := 1 to 13 do
  CardNumberStrings[t] := BasicCardNumberStrings[t];
  for h := 0 to 7 do
  for b := 0 to 12 do
  begin
    with CardPanels[b,h] do
    begin
      if LargeFlag then Width := 41 else Width := 30;
      if LargeFlag then Height := 52 else Height := 44;
      if LargeFlag then Left := 51 + b * (width + 5)
                   else Left := 42 + b * (width + 4);
      if LargeFlag then Top := 5 + h * (Height + 5)
                   else Top := 4 + h * (Height + 4);
      Tag := T;
      OnMouseDown := CardMouseDown;
    end;
    with CardColorLabels[b,h] do
    begin
      if LargeFlag then Top := 8 else Top := 5;
      if LargeFlag then Left := 1 else Left := -2;
    end;
    with CardNumberLabels[b,h] do
    begin
      if LargeFlag then Left := 1 else Left := -2;
      if LargeFlag then Top := 26 else Top := 23;
    end;
  end;
  for h := 0 to 7 do
  begin
    with APanels[h] do
    begin
      if LargeFlag then Width := 41 else Width := 30;
      if LargeFlag then Height := 52 else Height := 44;
      if LargeFlag then Left := 5 else Left := 8;
      if LargeFlag then Top := 5 + h * (Height + 5)
                   else Top := 4 + h * (Height + 4);
    end;
    with AColorLabels[h] do
    begin
      if LargeFlag then Top := 8 else Top := 5;
    end;
    with ANumberLabels[h] do
    begin
      if LargeFlag then Top := 26 else Top := 23;
    end;
  end;
end;

procedure TMontanaForm.FormCreate(Sender: TObject);
var
  h, b, t : integer;
  inifile : TIniFile;
begin
  Randomize;
  NameLabel.Caption := Player;
  MemoNl.Align := alClient;
  MemoEng.Align := alClient;
  LargeFlag := False;
  FastFlag := False;
  ColorFlag := False;
  IniFile := TInifile.Create(MontanaIniFilename);
  with inifile do
  begin
    LargeFlag := ReadBool('Options', 'Large', False);
    ColorFlag := ReadBool('Options', 'Color', False);
    FastFlag := ReadBool('Options', 'Fast', False);
    DutchFlag := ReadBool('Options', 'Lang', True);
    ChoiceU.Choice := ReadInteger('Last', Player, 0);
  end;
  IniFile.Free;
  clMark := clMarkNormal;
  PlaceForm;
  for h := 0 to 7 do
  for b := 0 to 12 do
  begin
    t := 13 * h + b;
    CardPanels[b,h] := TPanel.Create(Self);
    with CardPanels[b,h] do
    begin
      Tag := T;
      OnMouseDown := CardMouseDown;
      Caption := IntToStr(T);
    end;
    CardPanel.InsertControl(CardPanels[b,h]);
    CardColorLabels[b,h] := TLabel.Create(Self);
    with CardColorLabels[b,h] do
    begin
      Width := 39;
      Height := 18;
      Tag := T;
      Font.Name := 'Symbol';
      Font.Size := 12;
      Font.Style := [fsBold];
      Transparent := True;
      OnMouseDown := CardMouseDown;
    end;
    CardPanels[b,h].InsertControl(CardColorLabels[b,h]);
    CardNumberLabels[b,h] := TLabel.Create(Self);
    with CardNumberLabels[b,h] do
    begin
      Width := 39;
      Height := 18;
      Tag := T;
      Font.Name := 'Arial';
      Font.Size := 12;
      Font.Style := [fsBold];
      Transparent := True;
      OnMouseDown := CardMouseDown;
    end;
    CardPanels[b,h].InsertControl(CardNumberLabels[b,h]);
  end;
  for h := 0 to 7 do
  begin
    APanels[h] := TPanel.Create(Self);
    CardPanel.InsertControl(APanels[h]);
    AColorLabels[h] := TLabel.Create(Self);
    with AColorLabels[h] do
    begin
      Left := 1;
      Width := 39;
      Height := 18;
      Font.Name := 'Symbol';
      Font.Size := 12;
      Font.Style := [fsBold];
      Transparent := True;
    end;
    APanels[h].InsertControl(AColorLabels[h]);
    ANumberLabels[h] := TLabel.Create(Self);
    with ANumberLabels[h] do
    begin
      Left := 1;
      Width := 39;
      Height := 18;
      Font.Name := 'Arial';
      Font.Size := 12;
      Font.Style := [fsBold];
      Transparent := True;
    end;
    APanels[h].InsertControl(ANumberLabels[h]);
  end;
  PlaceCards;
  InitializeGame(ChoiceU.Choice);
  for b := 0 to 2 do SelectFlag[b] := False;
  if DutchFlag then DutchGame else EnglishGame;
end;

procedure TMontanaForm.SetColors;
{Deze procedure wordt alleen bij initialisatie aangeroepen als de kleuren
 worden ingesteld}
var b, h : integer;
begin
  {Kleuren toekennen}
  {clMarkNormal en clMarkWarning}
  for h := 0 to 7 do
  for b := 0 to 12 do
  begin
    if CardNumber[b,h] = b + 1 then CardPanels[b,h].Color := clMarkNormal;
    if (CardNumber[b,h] > b + 2) and (CardColor[b,h] = FinalCardColor[h])
      then CardPanels[b,h].Color := clMarkWarning;
    CardPanels[b,h].Font.Color := CardPanels[b,h].Color;
  end;
end;

procedure TMontanaForm.Select(no : integer);
begin
  OldColor[no] := CardPanels[SelectedB[no],SelectedH[no]].Color;
  if OldColor[no] = clDefault
    then CardPanels[SelectedB[no],SelectedH[no]].Color := clSelected
    else CardPanels[SelectedB[no],SelectedH[no]].Color := clMarkSelected;
  CardPanels[SelectedB[no],SelectedH[no]].Font.Color :=
             CardPanels[SelectedB[no],SelectedH[no]].Color;
  SelectFlag[no] := True;
  if no = 0 then CardPanels[SelectedB[no],SelectedH[no]].BevelOuter := bvLowered;
end;

procedure TMontanaForm.Unselect(no : integer);
begin
  CardPanels[SelectedB[no],SelectedH[no]].Color := OldColor[no];
  CardPanels[SelectedB[no],SelectedH[no]].Font.Color :=
             CardPanels[SelectedB[no],SelectedH[no]].Color;
  SelectFlag[no] := False;
  if no = 0 then
  begin
    CardPanels[SelectedB[no],SelectedH[no]].BevelOuter := bvRaised;
    if SelectFlag[1] then UnSelect(1);
    if SelectFlag[2] then UnSelect(2);
  end;
  OldColor[no] := 0;
end;

procedure TMontanaForm.SetCards; {controle + afhandeling bij einde}
var
  i, t, b, h, punten, deads, max, min, chc : integer;
  inifile : TIniFile;
begin
  punten := 4;
  deads := 0;
  chc := ChoiceU.Choice;
  for i := 0 to 7 do
  begin
    b := CardEmpty[i] mod 13;
    h := CardEmpty[i] div 13;
    t := 0;
    while (b >= 0) and (CardColor[b,h] = 0) do
    begin
      inc(t);
      dec(b);
    end;
    if (b = -1) or (CardNumber[b,h] + t <= 13) then CardEmptyState[i] := 0
                                               else CardEmptyState[i] := 1;
    b := CardEmpty[i] mod 13;
    h := CardEmpty[i] div 13;
    if CardEmptyState[i] = 1 then
    begin
      CardPanels[b,h].Color := clDead;
      inc(deads);
      CardPanels[b,h].Enabled := False;
      CardPanels[b,h].Font.Color := CardPanels[b,h].Color;
    end
    else
    begin
      CardPanels[b,h].Color := clEmpty;
      CardPanels[b,h].Enabled := True;
      CardPanels[b,h].Font.Color := CardPanels[b,h].Color;
    end
  end; {for i}
  for h := 0 to 7 do
  begin
    b := 0;
    while (CardColor[b,h] = FinalCardColor[h]) and (CardNumber[b,h] = b + 2) do
    begin
      CardPanels[b,h].Color := clReady;
      CardPanels[b,h].Font.Color := CardPanels[b,h].Color;
      inc(b);
      inc(punten);
    end;
    {eventuele clReady weer vervangen door clDefault}
    for i := b to 12 do
      if CardPanels[b,h].Color = clReady then
      begin
        CardPanels[b,h].Color := clDefault;
        CardPanels[b,h].Font.Color := clDefault;
      end;
  end;
  PuntenLabel.Caption := IntToStr(Punten);
  if deads = 8 then
  begin
    ShowMessage(Strings[4] + IntToStr(Punten) + ' punten');
    if chc > 0 then
    begin
      IniFile := TIniFile.Create(MontanaIniFileName);
      with IniFile do
      begin
        max := ReadInteger(Player + IntToStr(Chc), 'max', 0);
        min := ReadInteger(Player + IntToStr(Chc), 'min', 1000);
        if punten > max then
          WriteInteger(Player + IntToStr(Chc), 'max', punten);
        if (punten = 100) and (movecount < min) then
          WriteInteger(Player + IntToStr(Chc), 'min', movecount);
        max := ReadInteger(IntToStr(Chc), 'max', 0);
        min := ReadInteger(IntToStr(Chc), 'min', 1000);
        if punten > max then
        begin
          WriteInteger(IntToStr(Chc), 'max', punten);
          WriteString(IntToStr(Chc), 'author', Player);
        end;
        if (punten = 100) and (movecount < min) then
        begin
          WriteInteger(IntToStr(Chc), 'min', movecount);
          WriteString(IntToStr(Chc), 'author', Player);
        end;
      end;
      IniFile.Free;
    end;
  end;
end;

function TMontanaForm.PlaceCard(b, h : Integer) : Integer;
{De kaart op positie (b,h) wordt getoond.}
begin
  with CardColorLabels[b,h] do
  begin
    if CardColor[b,h] < 3 then Font.Color := clRed
                          else Font.Color := clBlack;
    Caption := CardColorChars[CardColor[b,h]];
  end;
  with CardNumberLabels[b,h] do
  begin
    if CardColor[b,h] < 3 then Font.Color := clRed
                          else Font.Color := clBlack;
    Caption := CardNumberStrings[CardNumber[b,h]];
  end;
  with CardPanels[b,h] do
  begin
    if CardNumber[b,h] = 1 then Color := clAse
    else if (b = 0) and (FinalCardColor[h] = CardColor[b,h])
                    and (CardNumber[b,h] = 2)
         then Color := clReady
    else if b = 0 then Color := clDefault
    else if CardNumber[b - 1,h] = 1 then Color := clDefault
    else Color := CardPanels[b - 1,h].Color;
    Enabled := True;
    Font.Color := Color;
    if Color = clMarkNormal then PlaceCard := 1
    else if Color = clMarkWarning then PlaceCard := 2
    else PlaceCard := 0;
  end;
end;

function TMontanaForm.RemoveCard(b, h : Integer) : Integer;
{De kaart op positie (b,h) wordt vervangen door een leegte.}
begin
  CardColorLabels[b,h].Caption := '';
  CardNumberLabels[b,h].Caption := '';
  CardNumber[b,h] := 0;
  CardColor[b,h] := 0;
  with CardPanels[b,h] do
  begin
    if Color = clMarkNormal then RemoveCard := 1 else
    if Color = clMarkWarning then RemoveCard := 2
                             else RemoveCard := 0;
    Color := clEmpty;
    Font.Color := clEmpty;
  end;
end;

procedure TMontanaForm.PlaceAse(h, ColorNo : Integer);
begin
  with AColorLabels[h] do
  begin
    Caption := CardColorChars[ColorNo];
    if ColorNo < 3 then Font.Color := clRed else Font.Color := clBlack;
  end;
  with ANumberLabels[h] do
  begin
    Caption := CardNumberStrings[1];
    if ColorNo < 3 then Font.Color := clRed else Font.Color := clBlack;
  end;
  APanels[h].Color := clReady;
end;

Function TMontanaForm.CheckCard(b1, h1, b2, h2 : Integer) : Boolean;
begin
  if b1 = -1
    then CheckCard := ((CardColor[b2,h2] = FinalCardColor[h1]) and
                       (CardNumber[b2,h2] = 2))
    else CheckCard := ((CardColor[b2,h2] = CardColor[b1,h1]) and
                       (CardNumber[b2,h2] = CardNumber[b1,h1] + 1));
end;

procedure TMontanaForm.CardMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var
  t, cn, b, h : integer;
  cc : TColor;
begin
  if (Button = mbLeft) or (Sender is TButton) or (Sender is TSpeedButton)
    then CardClick(Sender)
  else
  begin
    if Sender is TLabel
      then t := (Sender as TLabel).Tag
      else if Sender is TPanel then t := StrToInt((Sender as TPanel).Caption);
    b := t mod 13;
    h := t div 13;
    UndoLastAction;
    cc := CardColor[b,h];
    cn := CardNumber[b,h];
    if clMark = clSelected then
    begin
      if ToPanel.BevelOuter = bvLowered then ShowTo(b,h) else ShowFrom(b,h);
    end
    else
    if CardPanels[b,h].Color = clDefault
      then CardPanels[b,h].Color := clMark
      else CardPanels[b,h].Color := clDefault;
    CardPanels[b,h].Font.Color := CardPanels[b,h].Color;
  end;
end;

procedure TMontanaForm.CardClick(Sender: TObject);
var t, cn, cc, ep, b, h, i, c_br : integer;
  {C_br = Color: Black or Red}
  {ep   = Empty Position}
begin
  if Sender is TLabel then t := (Sender as TLabel).Tag
                      else t := StrToInt((Sender as TPanel).Caption);
  b := t mod 13;
  h := t div 13;
  cc := CardColor[b,h];
  c_br := (cc - 1) div 2;
  cn := CardNumber[b,h];
  if cc = 0 then
  begin
    ep := 0;
    while (CardEmpty[ep] <> T) and (ep < 8) do inc(ep);
    if ep = 8 then
    begin
      ShowMessage(Strings[3]);
      for i := 0 to 7 do
      begin
        b := CardEmpty[i] mod 13;
        h := CardEmpty[i] div 13;
        CardNumber[b,h] := 1;
        CardColor[b,h] := 1;
        PlaceCard(b,h);
      end;
    end;
    if ep = 8 then Exit;
  end;
  {Dit deel behandelt het kiezen van de azen.}
  if Phase < 2 then
  begin
    if CN = 1 then
    begin
      Moves[Phase - 2] := t;
      PlaceAse(Phase, CC);
      PlaceAse(Phase + 4, CC);
      FinalCardColor[Phase] := CC;
      FinalCardColor[Phase + 4] := CC;
      PlaceAse(Phase + 2, 3 + 4 * c_br - CC);
      PlaceAse(Phase + 6, 3 + 4 * c_br - CC);
      FinalCardColor[Phase + 2] := 3 + 4 * c_br - CC;
      FinalCardColor[Phase + 6] := 3 + 4 * c_br - CC;
      b := CardPosition[CN,CC,1] mod 13;
      h := CardPosition[CN,CC,1] div 13;
      CardEmpty[4 * Phase] := CardPosition[CN,CC,1];
      RemoveCard(b,h);
      CardPosition[CN,CC,1] := -1;
      b := CardPosition[CN,CC,2] mod 13;
      h := CardPosition[CN,CC,2] div 13;
      CardEmpty[4 * Phase + 1] := CardPosition[CN,CC,2];
      RemoveCard(b,h);
      CardPosition[CN,CC,1] := -1;
      b := CardPosition[CN,3 + 4 * c_br - CC,1] mod 13;
      h := CardPosition[CN,3 + 4 * c_br - CC,1] div 13;
      CardEmpty[4 * Phase + 2] := CardPosition[CN,3 + 4 * c_br - CC,1];
      RemoveCard(b,h);
      CardPosition[CN,CC,1] := -1;
      b := CardPosition[CN,3 + 4 * c_br - CC,2] mod 13;
      h := CardPosition[CN,3 + 4 * c_br - CC,2] div 13;
      CardEmpty[4 * Phase + 3] := CardPosition[CN,3 + 4 * c_br - CC,2];
      RemoveCard(b,h);
      CardPosition[CN,CC,1] := -1;
      inc(Phase);
    end
    else ShowMessage(Strings[1]);
    if Phase = 2 then
    begin
      SetCards;
      if ColorFlag then SetColors;
    end;
  end
  else {Gangbaar in het spel}
  begin
    if SelectFlag[0] then
    {Er was al een kaart of lege ruimte geselecteerd.}
    begin
      if (OldColor[0] = clEmpty) then
      {Er was een lege ruimte geselecteerd.}
      begin
        if CheckCard(SelectedB[0] - 1, SelectedH[0], b, h) then
        begin
          UnSelect(0);
          MoveCard(T, 13*SelectedH[0] + SelectedB[0]);
          SetCards;
        end
        else if (b = SelectedB[0]) and (h = SelectedH[0]) then UnSelect(0)
        else
        begin
          UnSelect(0);
          SelectedB[0] := b;
          SelectedH[0] := h;
          Select(0);
          //ShowMessage(Strings[2]);
          //MessageBeep(0);
        end;
      end
      else
      {Er was een kaart geselecteerd}
      begin
        if CheckCard(b - 1, h, SelectedB[0], SelectedH[0]) then
        begin
          UnSelect(0);
          MoveCard(13*SelectedH[0] + SelectedB[0], T);
          SetCards;
        end
        else if (b = SelectedB[0]) and (h = SelectedH[0]) then UnSelect(0)
        else
        begin
          UnSelect(0);
          SelectedB[0] := b;
          SelectedH[0] := h;
          Select(0);
          //ShowMessage(Strings[2]);
          //MessageBeep(0);
        end;
      end;
    end
    else
    {Er was nog niets geselecteerd.}
    begin
      if SelectFlag[1] then UnSelect(1);
      if SelectFlag[2] then UnSelect(2);
      SelectedB[0] := b;
      SelectedH[0] := h;
      if CC = 0 then ShowFrom(b, h);
      Select(0);
    end;
  end;
end;

function TMontanaForm.MoveCard(P1, P2 : Integer) : boolean;
{P1 is de plaats van de kaart, P2 de lege ruimte}
var b1, b2, h1, h2, i, cc1, cc2, cn1, ep, col : integer;
begin
  b1 := P1 mod 13;
  h1 := P1 div 13;
  b2 := P2 mod 13;
  h2 := P2 div 13;
  NewB := b2;
  NewH := h2;
  cc1 := CardColor[b1,h1];
  cc2 := CardColor[b2,h2];
  cn1 := CardNumber[b1,h1];
  if (cc1 <> 0) and (cc2 = 0) then
  begin
    ep := 0;
    while (ep < 8) and (CardEmpty[ep] <> P2) do inc(ep);
    if ep = 8 then
    begin
      ShowMessage(Strings[3]);
      MoveCard := False;
      exit;
    end;
    CardEmpty[ep] := P1;
    CardNumber[b2,h2] := CardNumber[b1,h1];
    CardColor[b2,h2] := CardColor[b1,h1];
    Col := RemoveCard(b1, h1);
    PlaceCard(b2, h2);
    if CardPosition[CN1, CC1, 1] = P1
      then CardPosition[CN1, CC1, 1] := P2
      else CardPosition[CN1, CC1, 2] := P2;
    Moves[MoveCount] := Col * Mod2 + P1 * Mod1 + P2;
    inc(MoveCount);
    MaxCount := MoveCount;
    SpeedButtonNext.Enabled := False;
    CountLabel.Caption := IntToStr(MoveCount);
    MoveCard := True;
  end
  else MoveCard := False;
end;

procedure TMontanaForm.Timer1Timer(Sender: TObject);
var b, h : integer;
begin
  if SelectFlag[0] then
  begin
    Unselect(0);
    Timer1.Enabled := false;
  end
  else
  begin
    Selectedb[0] := NewB;
    Selectedh[0] := NewH;
    Select(0);
  end;
  SpeedButtonPrevious.Enabled := True;
end;

procedure TMontanaForm.ShowTo(b, h : Integer);
var m : integer;
begin
  m := -1;
  if CardNumber[b,h] = 2 then
  begin
    SelectedB[1] := 0;
    m := 0;
    while FinalCardColor[m] <> CardColor[b,h] do inc(m);
    SelectedH[1] := m;
    SelectedB[2] := 0;
    SelectedH[2] := m + 4;
  end
  else if cardcolor[b,h] > 0 then
  begin
    m := CardPosition[CardNumber[b,h] - 1,CardColor[b,h],1];
    SelectedB[1] := m mod 13;
    SelectedH[1] := m div 13;
    if SelectedB[1] < 12 then SelectedB[1] := SelectedB[1] + 1;
    m := CardPosition[CardNumber[b,h] - 1,CardColor[b,h],2];
    SelectedB[2] := m mod 13;
    SelectedH[2] := m div 13;
    if SelectedB[2] < 12 then SelectedB[2] := SelectedB[2] + 1;
  end;
  if m > -1 then
  begin
    Select(1);
    Select(2);
  end;
end;

procedure TMontanaForm.ShowFrom(b, h : Integer);
var m : integer;
begin
  m := -1;
  if b = 0 then m := CardPosition[2,FinalCardColor[h],1]
           else if CardColor[b-1,h] <> 0 then
                m := CardPosition[CardNumber[b-1,h] + 1,CardColor[b-1,h],1];
  if m > -1 then
  begin
    SelectedB[1] := m mod 13;
    SelectedH[1] := m div 13;
    Select(1);
  end;
  if b = 0 then m := CardPosition[2,FinalCardColor[h],2]
           else if CardColor[b-1,h] <> 0 then
                m := CardPosition[CardNumber[b-1,h] + 1,CardColor[b-1,h],2];
  if m > -1 then
  begin
    SelectedB[2] := m mod 13;
    SelectedH[2] := m div 13;
    Select(2);
  end;
end;

procedure TMontanaForm.MarkOK1Click(Sender: TObject);
begin
  UndoLastAction;
  NormalPanel.BevelOuter := bvLowered;
  WarningPanel.BevelOuter := bvRaised;
  FromPanel.BevelOuter := bvRaised;
  ToPanel.BevelOuter := bvRaised;
  clMark := clMarkNormal;
  MarkOK1.Checked := True;
  MarkWarning1.Checked := False;
  ShowTo1.Checked := False;
  ShowFrom1.Checked := False;
end;

procedure TMontanaForm.MarkWarning1Click(Sender: TObject);
begin
  UndoLastAction;
  NormalPanel.BevelOuter := bvRaised;
  WarningPanel.BevelOuter := bvLowered;
  FromPanel.BevelOuter := bvRaised;
  ToPanel.BevelOuter := bvRaised;
  clMark := clMarkWarning;
  MarkOK1.Checked := False;
  MarkWarning1.Checked := True;
  ShowTo1.Checked := False;
  ShowFrom1.Checked := False;
end;

procedure TMontanaForm.ShowTo1Click(Sender: TObject);
begin
  UndoLastAction;
  NormalPanel.BevelOuter := bvRaised;
  WarningPanel.BevelOuter := bvRaised;
  FromPanel.BevelOuter := bvLowered;
  ToPanel.BevelOuter := bvRaised;
  clMark := clSelected;
  MarkOK1.Checked := False;
  MarkWarning1.Checked := False;
  ShowTo1.Checked := True;
  ShowFrom1.Checked := False;
end;

procedure TMontanaForm.ShowFrom1Click(Sender: TObject);
begin
  UndoLastAction;
  NormalPanel.BevelOuter := bvRaised;
  WarningPanel.BevelOuter := bvRaised;
  FromPanel.BevelOuter := bvRaised;
  ToPanel.BevelOuter := bvLowered;
  clMark := clSelected;
  MarkOK1.Checked := False;
  MarkWarning1.Checked := False;
  ShowTo1.Checked := False;
  ShowFrom1.Checked := True;
end;

procedure TMontanaForm.MarkPanelClick(Sender: TObject);
var T : Integer;
begin
  UndoLastAction;
  T := (Sender as TPanel).Tag;
  Case T of
  1:begin
      NormalPanel.BevelOuter := bvLowered;
      WarningPanel.BevelOuter := bvRaised;
      FromPanel.BevelOuter := bvRaised;
      ToPanel.BevelOuter := bvRaised;
      clMark := clMarkNormal;
    end;
  2:begin
      NormalPanel.BevelOuter := bvRaised;
      WarningPanel.BevelOuter := bvLowered;
      FromPanel.BevelOuter := bvRaised;
      ToPanel.BevelOuter := bvRaised;
      clMark := clMarkWarning;
    end;
  3:begin
      NormalPanel.BevelOuter := bvRaised;
      WarningPanel.BevelOuter := bvRaised;
      FromPanel.BevelOuter := bvLowered;
      ToPanel.BevelOuter := bvRaised;
      clMark := clSelected;
    end;
  4:begin
      NormalPanel.BevelOuter := bvRaised;
      WarningPanel.BevelOuter := bvRaised;
      FromPanel.BevelOuter := bvRaised;
      ToPanel.BevelOuter := bvLowered;
      clMark := clSelected;
    end;
  end;
end;

procedure TMontanaForm.UndoLastAction;
var b, h : integer;
begin
  if SelectFlag[0] then
  begin
    Unselect(0);
    CardPanels[Selectedb[0],SelectedH[0]].BevelOuter := bvRaised;
  end;
  if SelectFlag[1] then Unselect(1);
  if SelectFlag[2] then Unselect(2);
end;

procedure TMontanaForm.UndoButtonClick(Sender: TObject);
var S, T, b, h, newmove, col : integer;
begin
  UndoLastAction;
  if MoveCount > 0 then
  begin
    dec(MoveCount);
    Col := Moves[MoveCount] div Mod2;
    NewMove := Moves[MoveCount] mod Mod2;
    T := NewMove div Mod1;
    S := NewMove mod Mod1;
    if not FastFlag then
    begin
      SpeedButtonPrevious.Enabled := False;
      Timer1.Enabled := True;
      repeat
        Application.ProcessMessages;
      until not SelectFlag[0];
    end;
    MoveCard(S,T);
    b := t mod 13;
    h := t div 13;
    with CardPanels[b,h] do
    begin
      Enabled := True;
      case col of
        0: if b > 0 then
           if CardPanels[b - 1, h].Color = clReady
             then Color := CardPanels[b - 1, h].Color
             else Color := clDefault;
        1: Color := clMarkNormal;
        2: Color := clMarkWarning;
      end;
      Font.Color := Color;
    end;
    if not FastFlag then
    begin
      Timer1.Enabled := True;
      repeat
        Application.ProcessMessages;
      until not SelectFlag[0];
    end;
    dec(MoveCount);
    CountLabel.Caption := IntToStr(MoveCount);
    SetCards;
    if CardPanels[b,h].Color = clReady then
    begin
      if (b = 0) and
         ((CardNumber[b,h] <> 2) or (CardColor[b,h] <> FinalCardColor[h])) then
      begin
        CardPanels[b,h].Color := clDefault;
        CardPanels[b,h].Font.Color := CardPanels[b,h].Color;
      end
      else if (b > 0) and
         ((CardNumber[b,h] <> b + 2) or (CardColor[b,h] <> CardColor[b-1,h])) then
      begin
        CardPanels[b,h].Color := clDefault;
        CardPanels[b,h].Font.Color := CardPanels[b,h].Color;
      end
    end;
  end
  else RestartButtonClick(Sender);
  SpeedButtonNext.Enabled := True;
  SpeedButtonPrevious.Enabled := True;
end;

procedure TMontanaForm.NextButtonClick(Sender: TObject);
begin
  ShowMessage('Deze optie werkt nog niet...');
end;

procedure TMontanaForm.ButtonCloseHelpClick(Sender: TObject);
begin
  HelpPanel.Visible := False;
  PanelHelp.Visible := False;
  CardPanel.Visible := true;
  ActionPanel.Visible := true;
end;

procedure TMontanaForm.Exit1Click(Sender: TObject);
begin
  Close;
end;

procedure TMontanaForm.ResetButtonClick(Sender: TObject);
begin
  ChoiceU.ChoiceForm.ShowModal;
  InitializeGame(ChoiceU.Choice);
end;

procedure TMontanaForm.RestartButtonClick(Sender: TObject);
begin
  InitializeGame(-1);
end;

procedure TMontanaForm.About1Click(Sender: TObject);
begin
  ShowMessage('Montana'#13'werd geschreven door'#13'Matthijs Coster'#13'Zie ook http://home.pi.net/~mcoster/');
end;

procedure TMontanaForm.Settings1Click(Sender: TObject);
var
  IniFile : TIniFile;
  b, h : integer;
begin
  OptionForm.ShowModal;
  if OptionsU.ChangeFlag then
  begin
    if (OptionForm.RadioGroupAfmeting.ItemIndex = 1) <> LargeFlag then
    begin
      LargeFlag := (OptionForm.RadioGroupAfmeting.ItemIndex = 1);
      PlaceForm;
      PlaceCards;
    end;
    if (OptionForm.RadioGroupKleuren.ItemIndex = 1) <> ColorFlag then
      ColorFlag := (OptionForm.RadioGroupKleuren.ItemIndex = 1);
    if (OptionForm.RadioGroupAnnuleren.ItemIndex = 1) <> FastFlag then
      FastFlag := (OptionForm.RadioGroupAfmeting.ItemIndex = 1);
    if (OptionForm.RadioGroupTaal.ItemIndex = 0) <> DutchFlag then
    begin
      DutchFlag := (OptionForm.RadioGroupTaal.ItemIndex = 0);
      if DutchFlag then
      begin
        ChoiceForm.DutchGame;
        NameForm.DutchGame;
        OptionForm.DutchGame;
        DutchGame;
        for b := 0 to 12 do
        for h := 0 to 7 do
          CardNumberLabels[b,h].Caption := CardNumberStrings[CardNumber[b,h]];
      end
      else
      begin
        ChoiceForm.EnglishGame;
        NameForm.EnglishGame;
        OptionForm.EnglishGame;
        EnglishGame;
        for b := 0 to 12 do
        for h := 0 to 7 do
          CardNumberLabels[b,h].Caption := CardNumberStrings[CardNumber[b,h]];
      end
    end;
    IniFile := TInifile.Create(MontanaIniFilename);
    with inifile do
    begin
      WriteBool('Options', 'Large', LargeFlag);
      WriteBool('Options', 'Color', ColorFlag);
      WriteBool('Options', 'Fast', FastFlag);
      WriteBool('Options', 'Lang', DutchFlag);
    end;
    IniFile.Free;
  end;
end;

procedure TMontanaForm.SpeedButtonSaveClick(Sender: TObject);
begin
  ShowMessage('Deze optie werkt nog niet...');
end;

procedure TMontanaForm.SpeedButtonScoreClick(Sender: TObject);
begin
  ScoreForm := TScoreForm.Create(Application);
  ScoreForm.ShowModal;
  ScoreForm.Free;
end;

procedure TMontanaForm.Score1Click(Sender: TObject);
begin
  ScoreForm := TScoreForm.Create(Application);
  ScoreForm.ShowModal;
  ScoreForm.Free;
end;

procedure TMontanaForm.Help2Click(Sender: TObject);
begin
  HelpPanel.Visible := true;
  CardPanel.Visible := False;
  ActionPanel.Visible := False;
  PanelHelp.Visible := True;
end;

procedure TMontanaForm.FormClose(Sender: TObject;
  var Action: TCloseAction);
var IniFile : TInifile;
begin
  {Invullen van [Last]}
  IniFile := TInifile.Create(MontanaIniFilename);
  if Name <> '' then
    inifile.WriteInteger('Last', Player, ChoiceU.Choice);
  IniFile.Free;
end;

end.
