unit ScoreU;

interface

uses
  WinTypes, WinProcs, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Tablist, IniFiles, ExtCtrls, Buttons;

type
  TScoreForm = class(TForm)
    Label1: TLabel;
    TabList1: TTabList;
    BitBtn1: TBitBtn;
    PanelEnglish: TPanel;
    HeaderEnglish: THeader;
    PanelDutch: TPanel;
    HeaderDutch: THeader;
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    procedure DutchGame;
    procedure EnglishGame;
  end;

var
  ScoreForm: TScoreForm;

implementation

uses MontanaU;

{$R *.DFM}

procedure TScoreForm.DutchGame;
begin
end;

procedure TScoreForm.EnglishGame;
begin
  PanelDutch.Visible := False;
  PanelEnglish.Visible := True;
end;

procedure TScoreForm.FormCreate(Sender: TObject);
var
  IniFile : TIniFile;
  max, min, i : integer;
  pmax, pmin, tmax, tmin, CopyName, tab, by, itxt : String;
begin
  tab := chr(9);
  with HeaderDutch do
  begin
    SectionWidth[0] := 40;
    SectionWidth[1] := 15;
    SectionWidth[2] := 64;
    SectionWidth[3] := 15;
    SectionWidth[4] := 64;
  end;
  with HeaderEnglish do
  begin
    SectionWidth[0] := 40;
    SectionWidth[1] := 15;
    SectionWidth[2] := 64;
    SectionWidth[3] := 15;
    SectionWidth[4] := 64;
  end;
  CopyName := MontanaU.Player;
  if MontanaU.DutchFlag then
  begin
    Label1.Caption := 'Beste scores voor ' + CopyName;
    PanelDutch.Visible := True;
    PanelEnglish.Visible := False;
  end
  else
  begin
    Label1.Caption := 'Best scores for ' + CopyName;
    PanelDutch.Visible := False;
    PanelEnglish.Visible := True;
  end;
  IniFile := TIniFile.Create(MontanaU.MontanaIniFileName);
  with IniFile do
  begin
    for i := 1 to 100 do
    begin
      itxt := IntToStr(i);
      max := ReadInteger(itxt, 'max', 0);
      min := ReadInteger(itxt, 'min', 1000);
      if max = 0 then
      begin
        tmax := '-';
        tmin := '-';
        by := '';
      end
      else if min = 1000 then
      begin
        tmax := '-';
        tmin := IntToStr(max);
        by := ReadString(itxt, 'author', '');
      end
      else
      begin
        tmax := '+';
        tmin := IntToStr(min);
        by := ReadString(itxt, 'author', '');
      end;
      max := ReadInteger(CopyName + itxt, 'max', 0);
      min := ReadInteger(CopyName + itxt, 'min', 1000);
      if max = 0 then
      begin
        pmax := '-';
        pmin := '-';
      end
      else if min = 1000 then
      begin
        pmax := '-';
        pmin := IntToStr(max);
      end
      else
      begin
        pmax := '+';
        pmin := IntToStr(min);
      end;
      if i < 10 then itxt := '  ' + itxt
      else if i < 100 then itxt := ' ' + itxt;
      TabList1.Items.Add( itxt + '   ' + pmax + ' ' + pmin + tab + '   ' +
                          tmax + ' ' + tmin + tab + by);
    end;
  end;
  IniFile.Free;
end;

end.
